from typing import Any

import dream3d.simpl

class AlignSections(dream3d.simpl.AbstractFilter):
    AlignmentShiftFileName: str
    CellAttributeMatrixName: str
    DataContainerName: dream3d.simpl.DataArrayPath
    WriteAlignmentShifts: bool
    def __init__(self) -> None: ...
    def New(self, *args, **kwargs) -> Any: ...

class AlignSectionsFeature(AlignSections):
    GoodVoxelsArrayPath: dream3d.simpl.DataArrayPath
    def __init__(self) -> None: ...
    def New(self, *args, **kwargs) -> Any: ...

class AlignSectionsFeatureCentroid(AlignSections):
    GoodVoxelsArrayPath: dream3d.simpl.DataArrayPath
    ReferenceSlice: int
    UseReferenceSlice: bool
    def __init__(self) -> None: ...
    def New(self, *args, **kwargs) -> Any: ...

class AlignSectionsList(AlignSections):
    DREAM3DAlignmentFile: bool
    InputFile: str
    def __init__(self) -> None: ...
    def New(self, *args, **kwargs) -> Any: ...

class AlignSectionsMisorientation(AlignSections):
    CellPhasesArrayPath: dream3d.simpl.DataArrayPath
    CrystalStructuresArrayPath: dream3d.simpl.DataArrayPath
    GoodVoxelsArrayPath: dream3d.simpl.DataArrayPath
    MisorientationTolerance: float
    QuatsArrayPath: dream3d.simpl.DataArrayPath
    UseGoodVoxels: bool
    def __init__(self) -> None: ...
    def New(self, *args, **kwargs) -> Any: ...

class AlignSectionsMutualInformation(AlignSections):
    CellPhasesArrayPath: dream3d.simpl.DataArrayPath
    CrystalStructuresArrayPath: dream3d.simpl.DataArrayPath
    GoodVoxelsArrayPath: dream3d.simpl.DataArrayPath
    MisorientationTolerance: float
    QuatsArrayPath: dream3d.simpl.DataArrayPath
    UseGoodVoxels: bool
    def __init__(self) -> None: ...
    def New(self, *args, **kwargs) -> Any: ...

class CAxisSegmentFeatures(SegmentFeatures):
    ActiveArrayName: str
    CellFeatureAttributeMatrixName: str
    CellPhasesArrayPath: dream3d.simpl.DataArrayPath
    CrystalStructuresArrayPath: dream3d.simpl.DataArrayPath
    FeatureIdsArrayName: str
    GoodVoxelsArrayPath: dream3d.simpl.DataArrayPath
    MisorientationTolerance: float
    QuatsArrayPath: dream3d.simpl.DataArrayPath
    RandomizeFeatureIds: bool
    UseGoodVoxels: bool
    def __init__(self) -> None: ...
    def New(self, *args, **kwargs) -> Any: ...

class ComputeFeatureRect(dream3d.simpl.AbstractFilter):
    FeatureIdsArrayPath: dream3d.simpl.DataArrayPath
    FeatureRectArrayPath: dream3d.simpl.DataArrayPath
    def __init__(self) -> None: ...
    def New(self, *args, **kwargs) -> Any: ...

class EBSDSegmentFeatures(SegmentFeatures):
    ActiveArrayName: str
    CellFeatureAttributeMatrixName: str
    CellPhasesArrayPath: dream3d.simpl.DataArrayPath
    CrystalStructuresArrayPath: dream3d.simpl.DataArrayPath
    FeatureIdsArrayName: str
    GoodVoxelsArrayPath: dream3d.simpl.DataArrayPath
    MisorientationTolerance: float
    QuatsArrayPath: dream3d.simpl.DataArrayPath
    RandomizeFeatureIds: bool
    UseGoodVoxels: bool
    def __init__(self) -> None: ...
    def New(self, *args, **kwargs) -> Any: ...

class GroupFeatures(dream3d.simpl.AbstractFilter):
    ContiguousNeighborListArrayPath: dream3d.simpl.DataArrayPath
    NonContiguousNeighborListArrayPath: dream3d.simpl.DataArrayPath
    PatchGrouping: bool
    UseNonContiguousNeighbors: bool
    def __init__(self) -> None: ...
    def New(self, *args, **kwargs) -> Any: ...

class MergeColonies(GroupFeatures):
    ActiveArrayName: str
    AngleTolerance: float
    AvgQuatsArrayPath: dream3d.simpl.DataArrayPath
    AxisTolerance: float
    CellParentIdsArrayName: str
    CellPhasesArrayPath: dream3d.simpl.DataArrayPath
    CrystalStructuresArrayPath: dream3d.simpl.DataArrayPath
    FeatureIdsArrayPath: dream3d.simpl.DataArrayPath
    FeatureParentIdsArrayName: str
    FeaturePhasesArrayPath: dream3d.simpl.DataArrayPath
    GlobAlphaArrayName: str
    IdentifyGlobAlpha: bool
    NewCellFeatureAttributeMatrixName: str
    def __init__(self) -> None: ...
    def New(self, *args, **kwargs) -> Any: ...

class MergeTwins(GroupFeatures):
    ActiveArrayName: str
    AngleTolerance: float
    AvgQuatsArrayPath: dream3d.simpl.DataArrayPath
    AxisTolerance: float
    CellParentIdsArrayName: str
    ContiguousNeighborListArrayPath: dream3d.simpl.DataArrayPath
    CrystalStructuresArrayPath: dream3d.simpl.DataArrayPath
    FeatureIdsArrayPath: dream3d.simpl.DataArrayPath
    FeatureParentIdsArrayName: str
    FeaturePhasesArrayPath: dream3d.simpl.DataArrayPath
    NewCellFeatureAttributeMatrixName: str
    NonContiguousNeighborListArrayPath: dream3d.simpl.DataArrayPath
    UseNonContiguousNeighbors: bool
    def __init__(self) -> None: ...
    def New(self, *args, **kwargs) -> Any: ...

class ScalarSegmentFeatures(SegmentFeatures):
    ActiveArrayName: str
    CellFeatureAttributeMatrixName: str
    FeatureIdsArrayName: str
    GoodVoxelsArrayPath: dream3d.simpl.DataArrayPath
    RandomizeFeatureIds: bool
    ScalarArrayPath: dream3d.simpl.DataArrayPath
    ScalarTolerance: float
    UseGoodVoxels: bool
    def __init__(self) -> None: ...
    def New(self, *args, **kwargs) -> Any: ...

class SegmentFeatures(dream3d.simpl.AbstractFilter):
    DataContainerName: str
    def __init__(self) -> None: ...
    def New(self, *args, **kwargs) -> Any: ...
